/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * Warning! This file is generated. Modify at your own risk.
 */

package com.google.api.services.shopping.model;

import com.google.api.client.json.GenericJson;
import com.google.api.client.json.JsonString;

/**
 * Model definition for ShoppingModelDebugJsonV1.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Search API For Shopping. For a detailed explanation
 * see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * <p>
 * Upgrade warning: starting with version 1.12 {@code getResponseHeaders()} is removed, instead use
 * {@link com.google.api.client.http.json.JsonHttpRequest#getLastResponseHeaders()}
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class ShoppingModelDebugJsonV1 extends GenericJson {

  /**
   * Google internal
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<BackendTimes> backendTimes;

  static {
    // hack to force ProGuard to consider BackendTimes used, since otherwise it would be stripped out
    // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
    com.google.api.client.util.Data.nullOf(BackendTimes.class);
  }

  /**
   * Google internal.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key @JsonString
  private Long elapsedMillis;

  /**
   * Google internal.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String facetsRequest;

  /**
   * Google internal.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String facetsResponse;

  /**
   * Google internal.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String rdcResponse;

  /**
   * Google internal.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String recommendedItemsRequest;

  /**
   * Google internal.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String recommendedItemsResponse;

  /**
   * Google internal.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String searchRequest;

  /**
   * Google internal.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String searchResponse;

  /**
   * Google internal
   * The value returned may be {@code null}.
   */
  public java.util.List<BackendTimes> getBackendTimes() {
    return backendTimes;
  }

  /**
   * Google internal
   * The value set may be {@code null}.
   */
  public ShoppingModelDebugJsonV1 setBackendTimes(java.util.List<BackendTimes> backendTimes) {
    this.backendTimes = backendTimes;
    return this;
  }

  /**
   * Google internal.
   * The value returned may be {@code null}.
   */
  public Long getElapsedMillis() {
    return elapsedMillis;
  }

  /**
   * Google internal.
   * The value set may be {@code null}.
   */
  public ShoppingModelDebugJsonV1 setElapsedMillis(Long elapsedMillis) {
    this.elapsedMillis = elapsedMillis;
    return this;
  }

  /**
   * Google internal.
   * The value returned may be {@code null}.
   */
  public String getFacetsRequest() {
    return facetsRequest;
  }

  /**
   * Google internal.
   * The value set may be {@code null}.
   */
  public ShoppingModelDebugJsonV1 setFacetsRequest(String facetsRequest) {
    this.facetsRequest = facetsRequest;
    return this;
  }

  /**
   * Google internal.
   * The value returned may be {@code null}.
   */
  public String getFacetsResponse() {
    return facetsResponse;
  }

  /**
   * Google internal.
   * The value set may be {@code null}.
   */
  public ShoppingModelDebugJsonV1 setFacetsResponse(String facetsResponse) {
    this.facetsResponse = facetsResponse;
    return this;
  }

  /**
   * Google internal.
   * The value returned may be {@code null}.
   */
  public String getRdcResponse() {
    return rdcResponse;
  }

  /**
   * Google internal.
   * The value set may be {@code null}.
   */
  public ShoppingModelDebugJsonV1 setRdcResponse(String rdcResponse) {
    this.rdcResponse = rdcResponse;
    return this;
  }

  /**
   * Google internal.
   * The value returned may be {@code null}.
   */
  public String getRecommendedItemsRequest() {
    return recommendedItemsRequest;
  }

  /**
   * Google internal.
   * The value set may be {@code null}.
   */
  public ShoppingModelDebugJsonV1 setRecommendedItemsRequest(String recommendedItemsRequest) {
    this.recommendedItemsRequest = recommendedItemsRequest;
    return this;
  }

  /**
   * Google internal.
   * The value returned may be {@code null}.
   */
  public String getRecommendedItemsResponse() {
    return recommendedItemsResponse;
  }

  /**
   * Google internal.
   * The value set may be {@code null}.
   */
  public ShoppingModelDebugJsonV1 setRecommendedItemsResponse(String recommendedItemsResponse) {
    this.recommendedItemsResponse = recommendedItemsResponse;
    return this;
  }

  /**
   * Google internal.
   * The value returned may be {@code null}.
   */
  public String getSearchRequest() {
    return searchRequest;
  }

  /**
   * Google internal.
   * The value set may be {@code null}.
   */
  public ShoppingModelDebugJsonV1 setSearchRequest(String searchRequest) {
    this.searchRequest = searchRequest;
    return this;
  }

  /**
   * Google internal.
   * The value returned may be {@code null}.
   */
  public String getSearchResponse() {
    return searchResponse;
  }

  /**
   * Google internal.
   * The value set may be {@code null}.
   */
  public ShoppingModelDebugJsonV1 setSearchResponse(String searchResponse) {
    this.searchResponse = searchResponse;
    return this;
  }

  /**
   * Model definition for ShoppingModelDebugJsonV1BackendTimes.
   */
  public static final class BackendTimes extends GenericJson {

    /**
     * Google internal
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key @JsonString
    private Long elapsedMillis;

    /**
     * Google internal
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private String hostName;

    /**
     * Google internal
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private String name;

    /**
     * Google internal
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key @JsonString
    private Long serverMillis;

    /**
     * Google internal
     * The value returned may be {@code null}.
     */
    public Long getElapsedMillis() {
      return elapsedMillis;
    }

    /**
     * Google internal
     * The value set may be {@code null}.
     */
    public BackendTimes setElapsedMillis(Long elapsedMillis) {
      this.elapsedMillis = elapsedMillis;
      return this;
    }

    /**
     * Google internal
     * The value returned may be {@code null}.
     */
    public String getHostName() {
      return hostName;
    }

    /**
     * Google internal
     * The value set may be {@code null}.
     */
    public BackendTimes setHostName(String hostName) {
      this.hostName = hostName;
      return this;
    }

    /**
     * Google internal
     * The value returned may be {@code null}.
     */
    public String getName() {
      return name;
    }

    /**
     * Google internal
     * The value set may be {@code null}.
     */
    public BackendTimes setName(String name) {
      this.name = name;
      return this;
    }

    /**
     * Google internal
     * The value returned may be {@code null}.
     */
    public Long getServerMillis() {
      return serverMillis;
    }

    /**
     * Google internal
     * The value set may be {@code null}.
     */
    public BackendTimes setServerMillis(Long serverMillis) {
      this.serverMillis = serverMillis;
      return this;
    }

  }

}
